#!/usr/bin/perl
$| = 1;

##############################################################
#
#	Database_Doctor.cgi 2.0
#	Mike Carville
#	www.web-bazaar.com/cgi/
#	carville@web-bazaar.com
#
# 	This script is made available free of charge.
# 	Please leave my name in the header section.
# 	You may not sell this script for any reason.
#	While not required, please leave the banner in the footer
#	in the manager script to help fund further development.
#
#	If you are really thrilled with this script, why not help 
#	us both out and buy a reference book from our scripts page.
#	We get a commission, you get knowledge, and Amazon stockholders
#	breathe easier for another day. <:-)
#
#	The Database Doctor
#	-------------------
#	The Database Doctor is a tool designed to help manage
#	Pipe Delimited Databases.(|) The script is designed to
#	add to, edit and delete, sort and prepare printouts of
#	databases. Many scripts, especially web stores utilize
#	these types of data files.
#
#	The script is password protected, and has a user addition
#	form. 
#
#	Earlier versions of this script supported multiple users.
#	Nobody seemed to care, and it messed up a lot of people.
#	Out like the cat. In with the new.
#
#	Even though this was written to manage a webstore database,
#	everybody seemed to want a front end to this. Display.cgi
#	was written to address this. The Database Doctor will still
#	work wonderfully to create and maintain databases for an
#	inventory file. With display.cgi now it becomes flexible
#	and can easily handle address books, directories or whatever
#	you can imagine. And imagination is the key.
#
#
#	A key feature of the script is that it will edit any
#	number of fields in a database. 
#
#	-the database you make will have as many fields 
# 	 as set in the @table_names array below.
#
#	-if you subsequently add a field to the middle you 
# 	 will need to adjust your  database
#
#     -The Titles for the fields need to match the names
#	on the input form, and are contained within the @table_names array .
# 
# 	-The input form for new items is an html form module located in html.dat. 
#
#	-The Form can be whatever you like...you can have drop down 
#	 and so forth to speed up entry.
#
#	-The absolute key though is that the name of the fields in the form
#	 must match the headings for the fields in the @tables_names array below. This is how
#	 the script knows where the data is coming in from, and where to put it. 
#	 If you are missing data from an entry form you are having a matching problem
#	 
#	-Don't add an opening or closing form tag to html.dat...as that is in
#	the script itself.
#
#	PATH to PERL
#	------------
#
#	The first line of every cgi script contains the path to the perl interpreter on your server.
#	/usr/bin/perl is standard on most, some others use /usr/local/bin/perl
#	If you don't know where it is, ask your host, or if you have telnet, login and type whereis perl
#
#	FILES
#	-----
#
#	Make ABSOLUTELY sure to transfer the files in ASCII and not BINARY. BINARY breaks cgi scripts.
#
#	In the main CGI Directory place database_doctor.cgi(755)
#
# 	Contents (permissions in ())...	html.dat(666)
#					
#					DATABASE (name whatever you like)(666)
#
#	Place login_setup.cgi and users.dat wherever you want.
#	Login Setup will create the encrypted password.
#	There is a path to adjust the users.dat location on
#	the first line of login_setup.cgi
#
#	There are two logon pages included as well. Remember to changes the
#	paths to the scripts, and to leave the form input names alone.
#	One accesses the Database Doctor, the other will add users to users.dat.
#
#	One Other Option...
#	By setting the $check_items variable to Y the script will verify that the
#	first field in the entry you are adding is unique from all the others.
#	Most web store scripts require a unique item id.
#
#	ALWAYS BACK UP YOUR DATA MANUALLY!!!!
#
#
# 	We of course are not responsible if this script blows
# 	up your computer. We can, however, sell you a new one.
# 	At the point of this writing my computer has failed to blow up.
#
#	My personal friend and mentor Steven May contributed to this
#	script with the form parsing routine, and inspired the logic
#	behind parts of the search routine. You can see Steven's
#	work at http://www.blackwater-pacific.com/
#
#	And lastly, thanks to Joe DePasquale for the search routine I
#	borrowed from the linkmatic script before modifying. 
#
#
#
#	Improvements in version 2.0
#
#	-changed path structure to make installation easier
#
#	-added the ability to use get as well as post in the display script
#
#	-added a routine that limits the number of results from a search, and provides links to more results.
#
#	SET THESE FILE PATHS...you can add paths if you like,but having
#	paths caused lots of people not to be able to set it up right...so 
#	I gave up and took em out!

$database = "fsfprs.dat";   #just the name of the file

$users = "users.dat";

#change to Y if you would like the first field compared
#to the other first fields in the database during preview
#to insure a unique ID if you need that for a webstore

$check_items = "N";

@table_fields = ("First-Name","Last-Name","Business-Name","State","Email","Web-Site","Comment");




##################################################################################################
#####Thats that. You change below here and you mess with the guts...feel free but be careful######

print "Content-type: text/html\n\n";
print qq~
<html>
<head>
<title>Database Doctor 2.0</title>
</head>
<BODY basefont=-1>
<a href="http://www.web-bazaar.com/cgi/"><img src="http://www.web-bazaar.com/cgi/doctor2_0/dbdoclogo.jpg" alt="Database Doctor" border=0></a><P>
<FORM method=post action="database_doctor.cgi">
~;

##############################################################
#  Parse from the web form
##############################################################
read (STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@cgiPairs = split(/&/,$buffer);
foreach $cgiPair (@cgiPairs)
{
  ($name,$value) = split(/=/,$cgiPair);
  $value =~ s/\+/ /g;
  $value =~ s/%(..)/pack("c",hex($1))/ge;
  $form{$name} .= "\0" if (defined($form{$name}));
  $form{$name} .= "$value";
}



##############################################################
#  Validate User
##############################################################

	open (PEOPLE, "$users");

		while (<PEOPLE>)
		{
		$row=$_;
		@user = split(/ /,$row);

		if ($form{'user'} eq $user[0])
		{
		$password = crypt($form{'password'}, "MM");

		if ($password eq "$user[1]" )
		{$passwd="Y";}
		}
	}
	close (PEOPLE);


##############################################################
#  Set Hidden Tags for Re-entry
##############################################################
print qq~<INPUT type="hidden"  name="password" Value="$form{'password'}">\n~;
print qq~<INPUT type="hidden"  name="user" Value="$form{'user'}">\n~;



##############################################################
#  Display the Addition Form if necessary
##############################################################
$form {'startup'} and &display;


##############################################################
#  User Passes Check
##############################################################
if ($passwd eq "Y")
{



##############################################################
#  Preview the Addition
##############################################################

if ($form {'preview'})
{

	if ($check_items eq "Y")
	{&check_items;}

	print "<center><font size=4><b>Preview</b></font><table border=1 cellspacing =5 width=500>\n";

	foreach $table_fields (@table_fields)
	{

	if ($form{$table_fields} =~ /\n/)
	{
	print "<tr><th width=100>$table_fields</td>\n";
	print "<td><font size=-1><TEXTAREA  name=\"$table_fields\"  ROWS=8 COLS=60 wrap=physical>$form{$table_fields}</TEXTAREA></td></tr>\n";
	}

	else
	{
	print "<tr><th width=100>$table_fields</td>\n";
	print "<td width=400><INPUT type=\"text\"  name=\"$table_fields\" Value=\"$form{$table_fields}\" SIZE = \"40\" MAXSIZE = \"80\"></td></tr>\n";
	}

	}


	print "</tr></table>\n";
	print "<center><INPUT type=\"submit\"  name=\"add\" Value=\"  Add this to the Database  \">\n";

}



##############################################################
#  Make the Addition
##############################################################
if ($form {'add'})
{

	if ($check_items eq "Y")
	{&check_items;}

	$form{'Description'} =~ (s/\r\n/<br>/g);

	foreach $table_fields (@table_fields)
	{push (@row, "$form{$table_fields}");}

	$new_row = join ("\|", @row);


	open (DATABASE, ">>$database");
	print DATABASE "$new_row\n";
	close (DATABASE);



print "<center><h2>$form{$table_fields[1]} Item added to the Database</h2>";
&display;

}


##############################################################
#  Edit the Auction Database--Select an item
##############################################################

if ($form {'edit'})
{


	print"<table border=1 >\n";
	print"<tr><td><font size=-1><b>Edit</td><td><font size=-1><b>Delete</td>\n";

	foreach $table_fields (@table_fields)
	{print"<td><font size=-1><b>$table_fields</td>\n";}
	print"</tr>\n";

	$count=1;

	open (DATABASE, "$database");
	while (<DATABASE>)
	{
	$row = $_;
	chop $row;
	@fields = split (/\|/, $row);

	print "<tr><td align=center><font size=-1><input type=radio name=\"row_to_edit\" value=\"$count\"></td><td align=center><font size=-1><input type=checkbox name=\"delete$count\" value=\"$count\" ></td>\n";

	foreach $fields (@fields)
	{print"<td><font size=-1>$fields &nbsp;</td>\n";}

	print"</tr>\n";

	$count++;
	}
	close (DATABASE);

	$count--;

	print "</table>\n";
	print "<center><p><INPUT type=\"submit\"  name=\"edit_row\" Value=\"  Edit this row  \">\n";
	print "<center><INPUT type=\"submit\"  name=\"delete_row\" Value=\"  Delete this row  \"><P>\n";
      print " <p><b>Your search returned $count entries.</b><p>\n";


}
##############################################################
#  Edit--Print the web Page for changes
##############################################################
if ($form {'edit_row'})
{

	$count=1;

	open (DATABASE, "$database");
	while (<DATABASE>)
	{
	$row = $_;
	chop $row;
	@fields = split (/\|/, $row);


	if ($form{'row_to_edit'} eq $count)
	{
	$counter=0;

	foreach $table_fields (@table_fields)
	{
	$DATA{$table_fields} = "$fields[$counter]";
	$counter++;
	}

	print "<center><b>Correct any changes and press \"Change This Row\" to edit</b><p>\n";
	print "<table border=1 cellspacing =5 width=500>\n";

	foreach $table_fields (@table_fields)
	{

	if ($table_fields eq "Description")
	{
	print "<tr><th width=100>$table_fields</td>\n";
	print "<td><font size=-1><TEXTAREA  name=\"$table_fields\"  ROWS=8 COLS=40 wrap=physical>$DATA{$table_fields}</TEXTAREA></td></tr>\n";
	}

	else
	{
	print "<tr><th width=100>$table_fields</td>\n";
	print "<td width=400><INPUT type=\"text\"  name=\"$table_fields\" Value=\"$DATA{$table_fields}\" SIZE = \"40\" MAXSIZE = \"80\"></td></tr>\n";
	}

	}


	}
	$count++;
	}
	close (DATABASE);

	print "</table>\n";
	print "<INPUT type=\"hidden\"  name=\"row\" Value=\"$form{'row_to_edit'}\"><BR>\n";
	print "<center><INPUT type=\"submit\"  name=\"change_row\" Value=\"  Change this row  \"><P>\n";
}

##############################################################
#  Edit--Change Modified Row
##############################################################
if ($form {'change_row'})
{

	$count=1;
	$form{'Description'} =~ (s/\r\n/<br>/g);

	open (DATABASE, "$database");

	while (<DATABASE>)
	{
	$row = $_;
	chop $row;
	@fields = split (/\|/, $row);

	if ($form{'row'} ne $count)
	{$new_row .= "$row\n";}

	else
	{

	foreach $table_fields (@table_fields)
	{push (@row, "$form{$table_fields}");}

	$row = join ("\|", @row);
	$new_row .= "$row\n";
	}
	$count++;
	}
	close (DATABASE);


	open (DATABASE, ">$database");
	print DATABASE "$new_row";
	close (DATABASE);

	print "<center><h2>$form{$table_fields[1]} Item Modified</h2>";

}
##############################################################
#  Edit--Confirm Delete
##############################################################
if ($form {'delete_row'})
{
$count=1;


	print "<center><h1>Confirm Delete...Check box to delete...</h1>\n";
	print "<table border=1>\n";

	open (DATABASE, "$database");
	while (<DATABASE>)
	{
	$row = $_;
	chop $row;
	@fields = split (/\|/, $row);

	$selected="delete" . "$count";

	if ($form{$selected} eq $count)
	{print"<tr><td><font size=-1><input type=checkbox name=\"row$count\" value=\"$count\" checked></td><td><font size=-1>$fields[0]</td><td><font size=-1>$fields[1]</td><td><font size=-1>$fields[2]</td><td><font size=-1>$fields[3]</td><td><font size=-1>$fields[4]</td>\n";}

	$count++;
	}
	close (DATABASE);

	print "</table>\n";
	print "<INPUT type=\"hidden\"  name=\"data\" Value=\"$database\"><BR>\n";
	print "<center><INPUT type=\"submit\"  name=\"delete\" Value=\"  Purge!  \"><P>\n";

}

##############################################################
#  Edit--Delete Row
##############################################################
if ($form {'delete'})
{


	$count=1;

	open (DATABASE, "$database");
	while (<DATABASE>)
	{
	$row = $_;
	chop $row;
	@fields = split (/\|/, $row);

	$selected="row" . "$count";

	if ($form{$selected} ne $count)
	{$new_row .= "$row\n";}

	$count++;
	}
	close (DATABASE);


	open (DATABASE, ">$database");
	print DATABASE "$new_row";
	close (DATABASE);

	print "<center><h2>$form{$table_fields[1]} Item(s) Deleted</h2><P>\n";

}
##############################################################
#  Search Form
##############################################################
if ($form {'search'})
{

	print "Choose any combination of Search terms to locate entries to edit.<p>\n";
	print "SEARCH by Keywords:<BR>\n";

	print "<INPUT type=\"text\" name=\"searchtext\" size=60 maxlength=60>\n";
	print "<BR>Search for documents containing <INPUT type=\"radio\" name=\"searchtype\" value=\"any\" checked> ANY or <INPUT type=\"radio\" name=\"searchtype\" value=\"all\"> ALL of these words or phrases.\n";
	print "<br>Search only in this Field\n";
	print "<SELECT NAME = \"field\">\n";
	print "<OPTION value=\"\">\n";

	$count=0;
	foreach $table_fields (@table_fields)
	{
	print "<OPTION value =\"$count\">$table_fields\n";
	$count++;
	}

	print "<\select>\n";
	print "<CENTER><BR><INPUT type=\"submit\" name=\"find\" value=\"START SEARCH\"><p>\n";
}

##############################################################
#  Find Items and Display in Editor
##############################################################
if ($form {'find'})
{
	if ($form{'searchtext'})
	{ 
	@searchText = split(/\x20/,$form{'searchtext'});

	foreach $test (@searchText)
	{
 	if ($test =~ /\S{2,}/)
      {push (@searchKey, $test);}
	}


	if (! @searchKey)
	{print " <b>ERROR: No valid keywords were entered.</b><br>\n";}

	else
	{

	print"<table border=1 aline=center>\n";
	print"<tr><th><font size=\"-1\">Edit</th><th><font size=\"-1\">Delete</th>\n";

	foreach $table_fields (@table_fields)
	{print"<th><font size=\"-1\">$table_fields</th>\n";}

	print"</tr>\n";
	$count=1;

	open (DATABASE, "$database");
	while ($inLine = <DATABASE>)
	{
	$line=$inLine;

	if ( $form{'field'} ne "")
	{
	@fields = split (/\|/, $inLine);
	$inLine=$fields[$form{'field'}];
	}

	if ($form{'searchtype'} eq "any")
	{$foundFlag = "N";}
	else
	{$foundFlag = "Y";}

	foreach $test (@searchKey)
	{

	if ($inLine =~ /$test/i)
	{
	
		if ($form{'searchtype'} eq "any")
		{
		$foundFlag = "Y";
		last;
		}
	}
	else
	{

		if ($form{'searchtype'} eq "all")
		{
		$foundFlag = "N";
		last;
		}
	}

# end If InLine

	}
# end ForEach Test

	if ($foundFlag eq "Y")
	{
	@fields = split(/\|/,$line);
	$hitCount++;
	print "<tr><td><input type=radio name=\"row_to_edit\" value=\"$count\"></td><td><input type=checkbox name=\"delete$count\" value=\"$count\"></td>\n";

	foreach $fields (@fields)
	{print"<td><font size=\"-1\">$fields</td>\n";}
	print"</tr>\n";

	}

	$count++;
	
      } # end While InLine
      close(LINK);

	print "</table>\n";


	print "<center><INPUT type=\"submit\"  name=\"edit_row\" Value=\"  Edit this row  \">\n";
	print "<center><INPUT type=\"submit\"  name=\"delete_row\" Value=\"  Delete this row  \"><P>\n";
      print " <p><b>Your search returned $hitCount entries.</b><p>\n";

	}
	}
	 else # end Else StartSearch
	{print " ERROR: No keywords were entered.<p>\n";}

}

##############################################################
# Display the Sort Form
##############################################################
if ($form {'sort'})
{

	print "<BR>Field to sort by:\n";
	print "<SELECT NAME = \"sortby\">\n";

	$count=0;
	foreach $table_fields (@table_fields)
	{
	print "<OPTION value =\"$count\">$table_fields\n";
	$count++;
	}

	print "<\select><br>\n";

	print "Alphabetical <INPUT type=\"checkbox\" name=\"order\" value=\"alpha\" checked><BR>
	(Unchecking this box will result in reverse sort ...Z  to
	A or high to low in regards to prices.)<BR>\n";

	print "<center><INPUT type=\"Submit\"  name=\"sort_items\" Value=\"   Sort the Database \"><P>\n";

}
##############################################################
# Sort The Fields
##############################################################
if ($form {'sort_items'})
{


$index_of_field_to_be_sorted_by = $form{'sortby'};
$start_display = $form{'startdisplay'};
$display_end = $form{'displayend'};




#  First pick out the field, and move it to the beginning of the line

open(FILE, "$database");
flock(FILE, $LOCK_EX);
$count=0;
@row1 =<FILE>;
close (FILE);

while (@row1[$count] ne "")

	{
	$row = @row1[$count];
	@row = split (/\|/, $row);
	$sortable_field = $row[$index_of_field_to_be_sorted_by];
	unshift (@row, $sortable_field);
	$new_row = join ("\|", @row);
	push (@new_rows, $new_row);
	$count++
        }

# Next, sort the lines of the database

	if ($form{'order'} eq "alpha")
	{
	@sorted_rows = sort (@new_rows);
	}
	else
	{
	@sorted_rows = reverse sort (@new_rows);
	}

#now put the field back where it belongs

@database_rows = ();
 foreach $sorted_row (@sorted_rows)
    {
    @row = split (/\|/, $sorted_row);
    $sorted_field = shift (@row);
    $old_but_sorted_row = join ("\|", @row);
    push (@database_rows, $old_but_sorted_row);
    }


# print the results into the database

	open(FILE, ">$database");
     	print FILE (@database_rows);
	close(FILE);

print "<center><h2>Sorting Complete...</h2><P>\n";

}
##############################################################
# Display the Print Form
##############################################################
if ($form {'print'})
{

	print "<BR>Fields to Display:\n";
	print "<BR>Uncheck to remove from Printout Page...\n";

	$count=0;

	foreach $table_fields (@table_fields)
	{
	print "<br><INPUT type=\"checkbox\" name=\"$count\" value=\"$table_fields\" checked>$table_fields\n";
	$count++;
	}

	print "<center><INPUT type=\"Submit\"  name=\"print_display\" Value=\"   Prepare the Printout \"><P>\n";

}

##############################################################
# Display the Database for Printing
##############################################################
if ($form {'print_display'})
{


	print "<center><table border=0 cellspacing =5 width=500>\n";
	print "<tr>\n";

	$count=0;


	foreach $table_fields (@table_fields)
	{

	if ($form{$count} ne "")
	{print "<th width=100>$table_fields</td>\n";}

	$count++;

	}

	print "</tr>\n";


	open(DATABASE , "$database");
	while (<DATABASE>)
	{
	$row = $_;
	chop $row;
	@fields = split (/\|/, $row);

	print "<tr>\n";

	$count=0;

	foreach $fields(@fields)
	{

	if ($form{$count} ne "")
	{print "<td><font size=-1>$fields</td>\n";}

	$count++;

	}

	print "</tr>\n";

	}
	close (DATABASE);

	print "</table>\n";

	print "<p>\n";
}

##############################################################
# Display the Addition Form Subroutine
##############################################################
sub display
{
	open (DATABASE, "html.dat");

	while (<DATABASE>)
	{$html .= $_;}
	close (DATABASE);

	print "$html";
	print "<center><P><INPUT type=\"submit\"  name=\"add\" Value=\"  Add this directly to the Database  \">\n";
	print "<center><INPUT type=\"submit\"  name=\"preview\" Value=\"  Preview  \"><P>\n";
}
##############################################################
# Check Items for Duplicity in Item Number
##############################################################
sub check_items
{
	open (DATABASE, "$database");
	while (<DATABASE>)
	{
	$row = $_;
	chop $row;

	@fields = split (/\|/, $row);

	if ( $form{$table_fields[0]} eq $fields[0])
	{
	print "  <center><h2>Your Product-ID must be different from all the others.<br>Please use your back button to correct this...</h2>\n";
	print "</body>\n";
	print "</html>\n";
	exit;
	}

	}
	close (DATABASE);

}

##############################################################
# Display the footer
##############################################################

	print qq~<center>
	<P><hr><p>
	<center><P><INPUT type="Submit"  name="startup" Value="   Enter New Items Form">
	<INPUT type="Submit"  name="edit" Value="   Edit the Database ">
	<INPUT type="Submit"  name="sort" Value="   Sort the Database "><P>
	<INPUT type="Submit"  name="search" Value="   Search the Database ">
	<INPUT type="Submit"  name="print" Value="   Prepare a Printout "><p>
	<a href="display.cgi" target="_new">See the Data in Display.cgi Front End</a><p>
	<!-- START ADCYCLE.COM IFRAME RICH MEDIA CODE -->
	<!--  2000 AdCycle.com All Rights Reserved. -->
	<iframe src="http://www.strictlyexchange.com/adcycle/adcycle.cgi?group=6&media=1&id=1&delivery=iframe" height=60 width=468 border=0 marginheight=0 scrolling=no marginwidth=0 frameborder=no>
	<a href="http://www.strictlyexchange.com/adcycle/adclick.cgi?manager=adcycle.com&id=1" target="_top"><img src="http://www.strictlyexchange.com/adcycle/adcycle.cgi?group=6&media=1&id=1" width=468 height=60 border=1 ALT="Click to Visit"></a>
	</iframe>
	<!-- END ADCYCLE.COM IFRAME RICH MEDIA CODE -->
	<center>
	<p><font color="#000000"><font size=-2>Copyright (c) 1997-2000 <a href="http://www.web-bazaar.com/">The Web Bazaar</a> Database Doctor.
	<br>All rights reserved. Reproduction in whole or in part in any form or medium
	<br>without express written permission of The Web Bazaar is prohibited.</font></font></center>

	</body>
	</html>
	~;




}
	else
	{
	print "Incorrect logon. Use your back button to try again.";
	print"</body></html>\n";
	}

